Package: mcca
Type: Package
Title: Multi-Category Classification Accuracy
Version: 0.8.2
Authors@R: c(
    person(given = "Ming", family = "Gao", role = "aut"),
    person(given = "Jialiang", family = "Li",
           role = c("aut", "cre"),
           email = "stalj@nus.edu.sg"),
    person(given = "Pan", family = "Liu", role = "aut"),
    person(given = "Ben", family = "Van Calster", role = "aut")
    )
Maintainer: Jialiang Li <stalj@nus.edu.sg>
Description: It contains six common multi-category classification accuracy evaluation measures.
 All of these measures could be found in Li and Ming (2019) <doi:10.1002/sim.8103>. Specifically,
 Hypervolume Under Manifold (HUM), described in
 Li and Fine (2008) <doi:10.1093/biostatistics/kxm050>.
 Correct Classification Percentage (CCP), Integrated Discrimination Improvement (IDI), Net Reclassification Improvement (NRI), R-Squared Value (RSQ), described in
 Li, Jiang and Fine (2013) <doi:10.1093/biostatistics/kxs047>.
 Polytomous Discrimination Index (PDI), described in
 Van Calster et al. (2012) <doi:10.1007/s10654-012-9733-3>.
 Li et al. (2018) <doi:10.1177/0962280217692830>.
 PDI with variance estimation using Dover et al. (2021) <doi:10.1002/sim.9187>.
 We described all these above measures and our mcca package in
 Li, Gao and D'Agostino (2019) <doi:10.1002/sim.8103>.
License: GPL
Encoding: UTF-8
Imports: nnet,rpart,e1071,MASS,stats,pROC,caret
Suggests: rgl
URL: https://github.com/gaoming96/mcca
BugReports: https://github.com/gaoming96/mcca/issues
NeedsCompilation: no
Packaged: 2026-04-13 09:02:01 UTC; chrystalu
Author: Ming Gao [aut],
  Jialiang Li [aut, cre],
  Pan Liu [aut],
  Ben Van Calster [aut]
Repository: CRAN
Date/Publication: 2026-04-13 18:10:02 UTC
Built: R 4.5.2; ; 2026-04-13 19:26:15 UTC; unix

exportPattern("^[[:alpha:]]+")
import(nnet)
import(rpart)
import(e1071)
import(MASS)
import(stats)
importFrom(pROC, roc)
import(caret)
S3method(print, mcca.ccp)
S3method(print, mcca.pdi)
S3method(print, mcca.pdi.var)
S3method(print, mcca.rsq)
S3method(print, mcca.hum)
S3method(plot, mcca.hum)
importFrom("grDevices", "rainbow")
importFrom(utils, getFromNamespace)

pdi=function(y,d,method="multinom", withTies=TRUE,
             Var=FALSE, level=0.95, ...){

  y=factor(y)
  y_levels=levels(y)
  y=as.numeric(y)
  d=data.matrix(d)
  num=length(unique(y))

  pp=pm(y=y,d=d,method=method,...)
  pp=data.matrix(pp)
  
  #########################################
  if(Var){
    data_fast <- data.frame(
      outcome = factor(y, levels = seq_len(num))
    )
    data_fast <- cbind(data_fast, as.data.frame(pp))
    colnames(data_fast) <- c("outcome", paste0("p", seq_len(num)))
    
    var_res <- .pdi_var_efficient(
      data = data_fast,
      withTies = withTies
    )
    
    z_value <- qnorm(1 - (1 - level) / 2)
    
    pdi_overall <- var_res$pdi
    se_overall <- sqrt(var_res$sigma2 / nrow(data_fast))
    ci_overall <- c(
      max(0, pdi_overall - z_value * se_overall),
      min(1, pdi_overall + z_value * se_overall)
    )
    
    pdi_components <- var_res$pdi_categ
    se_components <- sqrt(var_res$sigma2_categ / nrow(data_fast))
    lower_components <- pmax(0, pdi_components - z_value * se_components)
    upper_components <- pmin(1, pdi_components + z_value * se_components)
    
    df <- data.frame(
      CATEGORIES = y_levels,
      VALUES = pdi_components,
      SE = se_components,
      LOWER_CI = lower_components,
      UPPER_CI = upper_components
    )
    
    result <- list(
      call = match.call(),
      measure = pdi_overall,
      se = se_overall,
      ci = ci_overall,
      level = level,
      table = df
    )
    
    class(result) <- "mcca.pdi.var"  
    return(result)
  }

  #########################################
  if(num==3 && !withTies){
    n1=which(y==1) #return the label
    n2=which(y==2)
    n3=which(y==3)
    pp1=pp[n1,]
    pp2=pp[n2,]
    pp3=pp[n3,]
    pdi1=0
    pdi2=0
    pdi3=0
    for(i in 1:length(n1)){
      pdi1=pdi1+sum(pp1[i,1]>pp2[,1])*sum(pp1[i,1]>pp3[,1])
    }
    for(i in 1:length(n2)){
      pdi2=pdi2+sum(pp2[i,2]>pp1[,2])*sum(pp2[i,2]>pp3[,2])
    }
    for(i in 1:length(n3)){
      pdi3=pdi3+sum(pp3[i,3]>pp1[,3])*sum(pp3[i,3]>pp2[,3])
    }
    pdi=(pdi1+pdi2+pdi3)/(3*length(n1)*length(n2)*length(n3))

    pdis=c(pdi1,pdi2,pdi3)/(length(n1)*length(n2)*length(n3))
    df=data.frame(CATEGORIES=sapply(1:num, function(i) y_levels[i]),VALUES=pdis)
    result=list(call=match.call(),measure=pdi,table=df)
    class(result)="mcca.pdi"
    return(result)

  #########################################
  }else if(num==4 && !withTies){
    n1=which(y==1) #return the label
    n2=which(y==2)
    n3=which(y==3)
    n4=which(y==4)
    pp1=pp[n1,]
    pp2=pp[n2,]
    pp3=pp[n3,]
    pp4=pp[n4,]
    pdi1=0
    pdi2=0
    pdi3=0
    pdi4=0
    for(i in 1:length(n1)){
      pdi1=pdi1+sum(pp1[i,1]>pp2[,1])*sum(pp1[i,1]>pp3[,1])*sum(pp1[i,1]>pp4[,1])
    }
    for(i in 1:length(n2)){
      pdi2=pdi2+sum(pp2[i,2]>pp1[,2])*sum(pp2[i,2]>pp3[,2])*sum(pp2[i,2]>pp4[,2])
    }
    for(i in 1:length(n3)){
      pdi3=pdi3+sum(pp3[i,3]>pp1[,3])*sum(pp3[i,3]>pp2[,3])*sum(pp3[i,3]>pp4[,3])
    }
    for(i in 1:length(n4)){
      pdi4=pdi4+sum(pp4[i,4]>pp1[,4])*sum(pp4[i,4]>pp2[,4])*sum(pp4[i,4]>pp3[,4])
    }
    pdi=(pdi1+pdi2+pdi3+pdi4)/(4*length(n1)*length(n2)*length(n3)*length(n4))

    pdis=c(pdi1,pdi2,pdi3,pdi4)/(length(n1)*length(n2)*length(n3)*length(n4))

    df=data.frame(CATEGORIES=sapply(1:num, function(i) y_levels[i]),VALUES=pdis)
    result=list(call=match.call(),measure=pdi,table=df)
    class(result)="mcca.pdi"
    return(result)

    #########################################

  }else if(num==2 && !withTies){
    n1=which(y==1) #return the label
    n2=which(y==2)
    pp1=pp[n1,]
    pp2=pp[n2,]

    pdi1=0
    pdi2=0

    for(i in 1:length(n1)){
      pdi1=pdi1+sum(pp1[i,1]>pp2[,1])+sum(pp1[i,1]==pp2[,1])
    }
    for(i in 1:length(n2)){
      pdi2=pdi2+sum(pp2[i,2]>pp1[,2])
    }

    pdi=(pdi1+pdi2)/(2*length(n1)*length(n2))

    pdis=c(pdi1,pdi2)/(length(n1)*length(n2))
    df=data.frame(CATEGORIES=sapply(1:num, function(i) y_levels[i]),VALUES=pdis)
    result=list(call=match.call(),measure=pdi,table=df)
    class(result)="mcca.pdi"
    return(result)
    
    #########################################
  }else{
    data_dover <- data.frame(outcome = y, pp)
    colnames(data_dover) <- c("outcome", paste0("p", 1:num))
    
    est <- .pdiest_dover(data_dover)
    
    pdi_overall <- as.numeric(est[1, 1])
    pdi_components <- as.numeric(est[-1, 1])
    
    df <- data.frame(
      CATEGORIES = sapply(1:num, function(i) y_levels[i]),
      VALUES = pdi_components
    )
    
    result <- list(
      call = match.call(),
      measure = pdi_overall,
      table = df
    )
    class(result) <- "mcca.pdi"
    return(result)
  }
  
}




###########################################################
# PDI Estimation in general cases using Dover et al. (2021) method
# Reference: Dover DC, Savu A, Engel B.
# Statistics in Medicine, 2021.
###########################################################
# Original implementation by:
# Anamaria Savu, PhD
# Canadian VIGOUR Centre
# University of Alberta
# savu@ualberta.ca
# November 2020
###########################################################

# Internal function: Estimates PDI and its components from probability matrix
# data: data.frame with $outcome and probability columns ($p1, $p2, ...)
#
# Usage notes:
# data must have one of its components named $outcome for storing
# the outcome values. The values of the outcome must cover all integer
# values between a lower and an upper bound. The remaining components
# of the data frame ($p1, $p2, ...) must record the estimated probabilities
# in a specific order: $p1 probabilities for the lowest value of the outcome,
# $p2 probabilities for the second lowest value of the outcome, and so on.
###########################################################
.pdiest_dover <- function(data) {
  y_raw <- data$outcome
  ymin <- min(y_raw)
  ymax <- max(y_raw)
  y_levels <- as.character(ymin:ymax)
  y <- factor(y_raw, levels = ymin:ymax)
  
  noutcome <- ymax - ymin
  p <- prod(table(y))
  pdi <- NULL
  
  for (i in seq_len(noutcome + 1)) {
    predprob <- data[[i + 1]]
    
    t0 <- table(predprob, y)
    t0 <- as.matrix(t0)
    
    if (!all(y_levels %in% colnames(t0))) {
      missing_cols <- setdiff(y_levels, colnames(t0))
      add_cols <- matrix(
        0,
        nrow = nrow(t0),
        ncol = length(missing_cols),
        dimnames = list(rownames(t0), missing_cols)
      )
      t0 <- cbind(t0, add_cols)
    }
    
    t0 <- t0[, y_levels, drop = FALSE]
    
    t <- cbind(
      t0[, i, drop = FALSE],
      t0[, -i, drop = FALSE]
    )
    
    restrictt <- if (noutcome == 1) {
      matrix(t[, 2, drop = TRUE], ncol = 1)
    } else {
      t[, 2:(noutcome + 1), drop = FALSE]
    }
    
    cmat <- apply(restrictt, 2, cumsum)
    if (is.null(dim(cmat))) {
      cmat <- matrix(cmat, ncol = noutcome)
    }
    
    if (nrow(cmat) == 1) {
      cnew <- matrix(0, nrow = 1, ncol = noutcome)
    } else {
      cnew <- rbind(
        matrix(0, nrow = 1, ncol = noutcome),
        cmat[seq_len(nrow(cmat) - 1), , drop = FALSE]
      )
    }
    
    mat <- NULL
    for (j in seq_len(noutcome)) {
      mat0 <- cbind(mat, 0)
      mat1 <- cbind(mat, 1)
      mat <- rbind(mat0, mat1)
    }
    
    r <- 0
    for (k in seq_len(nrow(mat))) {
      dt <- t(apply(restrictt, 1, function(x) mat[k, ] * x))
      dcnew <- t(apply(cnew, 1, function(x) (1 - mat[k, ]) * x))
      
      if (is.null(dim(dt))) {
        dt <- matrix(dt, ncol = noutcome)
      }
      if (is.null(dim(dcnew))) {
        dcnew <- matrix(dcnew, ncol = noutcome)
      }
      
      if (noutcome == 1) {
        dfinal <- cbind(
          t[, 1, drop = FALSE],
          matrix(dt + dcnew, ncol = 1)
        )
      } else {
        dfinal <- cbind(
          t[, 1, drop = FALSE],
          dt + dcnew
        )
      }
      
      r <- r + sum(apply(dfinal, 1, prod)) / (1 + sum(mat[k, ]))
    }
    
    r <- r / p
    pdi <- rbind(pdi, r)
  }
  
  pdi <- rbind(mean(pdi), pdi)
  rownames(pdi) <- NULL
  pdi
}


###########################################################
# PDI with efficient variance estimation
# Reference: Feng Q, Jia T, Liu P, Van Calster B, Li J.
# Statistics in Medicine, 2026.
###########################################################

# Internal function: Estimates PDI, its variance, standard deviation, and 
# confidence interval from probability matrix data: data.frame with $outcome 
# and probability columns ($p1, $p2, ...)
#
# Usage notes:
# data must have one of its components named $outcome for storing
# the outcome values. The values of the outcome must cover all integer
# values between a lower and an upper bound. The remaining components
# of the data frame ($p1, $p2, ...) must record the estimated probabilities
# in a specific order: $p1 probabilities for the lowest value of the outcome,
# $p2 probabilities for the second lowest value of the outcome, and so on.
###########################################################

.pdi_var_efficient <- function(data, withTies = TRUE) {
  
  y <- data$outcome
  y_char <- as.character(y)
  n <- length(y)
  categ_table <- table(y)
  categ <- names(categ_table)
  M <- length(categ)
  sz_prod <- prod(categ_table)
  
  if (withTies) {
    
    matC_init <- c()
    for (j in 1:(M - 1)) {
      matC0 <- cbind(matC_init, 0)
      matC1 <- cbind(matC_init, 1)
      matC_init <- rbind(matC0, matC1)
    }
    matC_init <- cbind(1, matC_init)
    
    pdi_categ <- c()
    pdi_sub <- c()
    
    for (a in 1:M) {
      
      predprob <- data[, a + 1]
      nn <- table(predprob, y)
      nn <- as.matrix(nn)
      
      NN_temp <- apply(nn, 2, cumsum)
      
      if (is.null(dim(NN_temp))) {
        NN_temp <- matrix(NN_temp, nrow = nrow(nn), ncol = ncol(nn))
        colnames(NN_temp) <- colnames(nn)
        rownames(NN_temp) <- rownames(nn)
      }
      
      if (nrow(NN_temp) == 1) {
        NN <- matrix(0, nrow = 1, ncol = M)
        colnames(NN) <- colnames(NN_temp)
        rownames(NN) <- rownames(NN_temp)
      } else {
        NN <- rbind(
          matrix(0, nrow = 1, ncol = M),
          NN_temp[1:(nrow(NN_temp) - 1), , drop = FALSE]
        )
        colnames(NN) <- colnames(NN_temp)
        rownames(NN) <- rownames(NN_temp)
      }
      
      aid <- which(y == levels(y)[a])
      S_a <- unique(predprob[aid])
      S_card <- length(S_a)
      
      nn_a <- nn[as.character(S_a), , drop = FALSE]
      NN_a <- NN[as.character(S_a), , drop = FALSE]
      
      matC <- matC_init
      matC[, 1] <- matC[, a]
      matC[, a] <- 1
      
      r <- 0
      A <- matrix(0, nrow = S_card, ncol = n)
      
      for (k in 1:nrow(matC)) {
        
        cc <- matC[k, ]
        names(cc) <- categ
        
        cc_mat <- matrix(cc, nrow = nrow(nn_a), ncol = ncol(nn_a), byrow = TRUE)
        dfinal <- cc_mat * nn_a + (1 - cc_mat) * NN_a
        
        row_prod <- apply(dfinal, 1, prod)
        zero_count <- rowSums(dfinal == 0)
        dfinal_all <- matrix(0, nrow(dfinal), ncol(dfinal))
        
        idx0 <- which(zero_count == 0)
        if (length(idx0) > 0) {
          dfinal_all[idx0, ] <- row_prod[idx0] / dfinal[idx0, ]
        }
        
        idx1 <- which(zero_count == 1)
        if (length(idx1) > 0) {
          for (i in idx1) {
            zero_idx <- which(dfinal[i, ] == 0)
            dfinal_all[i, zero_idx] <- prod(dfinal[i, -zero_idx])
          }
        }
        
        colnames(dfinal_all) <- categ
        dfinal_all <- dfinal_all[, y_char, drop = FALSE]
        
        matC_all <- cc[y_char]
        numerator <- t(sapply(S_a, function(pp) {
          matC_all * (predprob == pp) + (1 - matC_all) * (predprob < pp)
        }))
        
        A <- A + numerator * dfinal_all / sum(cc)
        r <- r + sum(apply(dfinal, 1, prod)) / sum(cc)
      }
      
      AA <- apply(A, 2, sum)
      pdi_sub <- cbind(pdi_sub, AA / sz_prod)
      pdi_categ <- c(pdi_categ, r / sz_prod)
    }
    
  } else {
    
    pdi_categ <- c()
    pdi_sub <- c()
    
    for (a in 1:M) {
      
      predprob <- data[, a + 1]
      nn <- table(predprob, y)
      nn <- as.matrix(nn)
      
      NN_temp <- apply(nn, 2, cumsum)
      
      if (is.null(dim(NN_temp))) {
        NN_temp <- matrix(NN_temp, nrow = nrow(nn), ncol = ncol(nn))
        colnames(NN_temp) <- colnames(nn)
        rownames(NN_temp) <- rownames(nn)
      }
      
      if (nrow(NN_temp) == 1) {
        NN <- matrix(0, nrow = 1, ncol = M)
        colnames(NN) <- colnames(NN_temp)
        rownames(NN) <- rownames(NN_temp)
      } else {
        NN <- rbind(
          matrix(0, nrow = 1, ncol = M),
          NN_temp[1:(nrow(NN_temp) - 1), , drop = FALSE]
        )
        colnames(NN) <- colnames(NN_temp)
        rownames(NN) <- rownames(NN_temp)
      }
      
      aid <- which(y == levels(y)[a])
      S_a <- unique(predprob[aid])
      
      nn_a <- nn[as.character(S_a), , drop = FALSE]
      NN_a <- NN[as.character(S_a), , drop = FALSE]
      
      dfinal <- NN_a
      dfinal[, a] <- 1
      
      row_prod <- apply(dfinal, 1, prod)
      zero_count <- rowSums(dfinal == 0)
      dfinal_all <- matrix(0, nrow(dfinal), ncol(dfinal))
      
      idx0 <- which(zero_count == 0)
      if (length(idx0) > 0) {
        dfinal_all[idx0, ] <- row_prod[idx0] / dfinal[idx0, ]
      }
      
      idx1 <- which(zero_count == 1)
      if (length(idx1) > 0) {
        for (i in idx1) {
          zero_idx <- which(dfinal[i, ] == 0)
          dfinal_all[i, zero_idx] <- prod(dfinal[i, -zero_idx])
        }
      }
      
      colnames(dfinal_all) <- categ
      dfinal_all <- dfinal_all[, y_char, drop = FALSE]
      
      numerator <- t(sapply(S_a, function(pp) {
        predprob < pp
      }))
      
      A <- numerator * dfinal_all
      r <- sum(apply(dfinal, 1, prod))
      
      AA <- apply(A, 2, sum)
      AA_a <- dfinal_all[, aid[1]][match(predprob[aid], S_a)]
      AA[aid] <- AA_a
      
      pdi_sub <- cbind(pdi_sub, AA / sz_prod)
      pdi_categ <- c(pdi_categ, r / sz_prod)
    }
  }
  
  names(pdi_categ) <- categ
  colnames(pdi_sub) <- categ
  
  pdi <- mean(pdi_categ)
  
  sigma2_term1 <- n * sum(apply(pdi_sub, 1, function(x) (mean(x))^2))
  sigma2_term2 <- n * pdi^2 * sum(1 / categ_table)
  sigma2 <- sigma2_term1 - sigma2_term2
  
  # category-specific asymptotic variance
  sigma2_categ <- sapply(1:M, function(a) {
    n * sum(pdi_sub[, a]^2) - n * pdi_categ[a]^2 * sum(1 / categ_table)
  })
  
  sigma2 <- max(as.numeric(sigma2), 0)
  sigma2_categ <- pmax(as.numeric(sigma2_categ), 0)
  
  list(
    pdi = as.numeric(pdi),
    sigma2 = sigma2,
    pdi_categ = as.numeric(pdi_categ),
    sigma2_categ = sigma2_categ,
    categories = categ
  )
}

nri=function(y,m1,m2,method="multinom",...){
  if (method!="prob"&method!="label"){
    ccp1=ccp(y=y,d=m1,method=method,...)$measure
    ccp2=ccp(y=y,d=cbind(m1,m2),method=method,...)$measure
  }else{
    ccp1=ccp(y=y,d=m1,method=method,...)$measure
    ccp2=ccp(y=y,d=m2,method=method,...)$measure
  }
  return(ccp2-ccp1)

}

ccp=function(y,d,method="multinom",...){

  # transform to numeric&matrix
  y=factor(y)
  y_levels=levels(y)
  y=as.numeric(y)
  d=data.matrix(d)

  #determine label vector pv from y, d and method
  if(method=="multinom"){
    #require(nnet)
    fit = nnet::multinom(y~d,...)
    pv=predict(fit,type='class')
  }else if(method=="tree"){
    #require(rpart)
    y = as.factor(y)
    fit = rpart::rpart(y~d,...)
    pv = predict(fit,type="class")
  }else if(method=="svm"){
    #require(e1071)
    y = as.factor(y)
    fit = e1071::svm(y~d,...)
    pv = predict(fit)
  }else if(method=="lda"){
    #require(MASS)
    fit = MASS::lda(y~d,...)
    predict.test.fit = predict(fit)
    pv = predict.test.fit$class

  }else if(method=="label"){
    temp = sum(d %in% 1:length(unique(y)))
    if (temp!=length(d)){
      cat("ERROR: The input value \"d\" should be a label vector encoded same as y.")
      return(NULL)
    }
    pv=d

  }else if(method=="prob"){
    l=max.col(d)
    for(i in 1:nrow(d)){
      if (length(which(max(d[i,])==d[i,]))>1){
        cat("WARNING: there exists two same max probability in one sample.\n")
        break
      }
    }
    pv=l
  }


  k=length(unique(y))
  ns=sapply(1:k, function(i) sum(y==i) )
  nn=sum(ns)
  ros=ns/nn
  ccps=sapply(1:k, function(i) sum(y==i & pv==i)/ns[i] )
  ccp=sum(ccps*ros)

  df=data.frame(CATEGORIES=sapply(1:k, function(i) y_levels[i]),VALUES=ccps,PREVALENCE=ros)
  result=list(call=match.call(),measure=ccp,table=df)

  class(result)="mcca.ccp"

  return(result)
}

estp <- function (y, m1, m2, acc = "idi", level = 0.95, method = "multinom",B=250,balance=FALSE, ...) {

  k=length(unique(y))
  series=numeric()

  if (acc=="idi"){
    if (balance==FALSE){
    for (b in 1:B){
      nn <- length(y)
      id <- sample(1:nn,nn,replace = T)
      #id <- unique(id)
      while (length(unique(y[id]))<k){
        id <- sample(1:nn,nn,replace = T)
        #id <- unique(id)
      }
      if ( "numeric" %in% class(m1) & "numeric" %in% class(m2) ){
        series[b] <- idi(y=y[id],m1=m1[id],m2=m2[id],method=method,...)
      }else if ("numeric" %in% class(m1)){
        series[b] <- idi(y=y[id],m1=m1[id],m2=m2[id,],method=method,...)
      }else if ("numeric" %in% class(m2)){
        series[b] <- idi(y=y[id],m1=m1[id,],m2=m2[id],method=method,...)
      }else {
        series[b] <- idi(y=y[id],m1=m1[id,],m2=m2[id,],method=method,...)
      }

    }
    }
    if (balance==TRUE){
      for (b in 1:B){
        id <- unlist(caret::createResample(y, times = 1))
        if ( "numeric" %in% class(m1) & "numeric" %in% class(m2) ){
          series[b] <- idi(y=y[id],m1=m1[id],m2=m2[id],method=method,...)
        }else if ("numeric" %in% class(m1)){
          series[b] <- idi(y=y[id],m1=m1[id],m2=m2[id,],method=method,...)
        }else if ("numeric" %in% class(m2)){
          series[b] <- idi(y=y[id],m1=m1[id,],m2=m2[id],method=method,...)
        }else {
          series[b] <- idi(y=y[id],m1=m1[id,],m2=m2[id,],method=method,...)
        }
      }
    }
    series.sort <- sort(series)
    return(list(value=idi(y=y,m1=m1,m2=m2,method=method,...),
                se=sd(series),
                interval=c(series.sort[ifelse(B*(0.5-level/2)<1,1,B*(0.5-level/2))],series.sort[B*(0.5+level/2)])))
  }
  if (acc=="nri"){
    if (balance==FALSE){
    for (b in 1:B){
      nn <- length(y)
      id <- sample(1:nn,nn,replace = T)
      #id <- unique(id)
      while (length(unique(y[id]))<k){
        id <- sample(1:nn,nn,replace = T)
        #id <- unique(id)
      }
      if ( "numeric" %in% class(m1) & "numeric" %in% class(m2) ){
        series[b] <- nri(y=y[id],m1=m1[id],m2=m2[id],method=method,...)
      }else if ("numeric" %in% class(m1)){
        series[b] <- nri(y=y[id],m1=m1[id],m2=m2[id,],method=method,...)
      }else if ("numeric" %in% class(m2)){
        series[b] <- nri(y=y[id],m1=m1[id,],m2=m2[id],method=method,...)
      }else {
        series[b] <- nri(y=y[id],m1=m1[id,],m2=m2[id,],method=method,...)
      }
    }
    }
    if (balance==TRUE){
      for (b in 1:B){
        id <- unlist(caret::createResample(y, times = 1))
        if ( "numeric" %in% class(m1) & "numeric" %in% class(m2) ){
          series[b] <- nri(y=y[id],m1=m1[id],m2=m2[id],method=method,...)
        }else if ("numeric" %in% class(m1)){
          series[b] <- nri(y=y[id],m1=m1[id],m2=m2[id,],method=method,...)
        }else if ("numeric" %in% class(m2)){
          series[b] <- nri(y=y[id],m1=m1[id,],m2=m2[id],method=method,...)
        }else {
          series[b] <- nri(y=y[id],m1=m1[id,],m2=m2[id,],method=method,...)
        }
      }
    }
    series.sort <- sort(series)
    return(list(value=nri(y=y,m1=m1,m2=m2,method=method,...),
                se=sd(series),
                interval=c(series.sort[ifelse(B*(0.5-level/2)<1,1,B*(0.5-level/2))],series.sort[B*(0.5+level/2)])))
  }


}

hum=function(y,d,method="multinom",...){

  y_raw=y
  y=factor(y)
  y_levels=levels(y)
  y=as.numeric(y)
  d=data.matrix(d)
  num=length(unique(y))

  pp=pm(y=y,d=d,method=method,...)

  if(num==3){
  x1=which(y==1) #return the label
  x2=which(y==2)
  x3=which(y==3)
  n=length(y)

  #n is the sample size
  a=matrix(0,n,3);
  one1=a;
  one1[,1]=1;
  one2=a;
  one2[,2]=1;
  one3=a;
  one3[,3]=1;

  #get cr value
  dd1=pp-one1;
  dd2=pp-one2;
  dd3=pp-one3;

  jd1=sqrt(dd1[,1]^2+dd1[,2]^2+dd1[,3]^2);
  jd2=sqrt(dd2[,1]^2+dd2[,2]^2+dd2[,3]^2);
  jd3=sqrt(dd3[,1]^2+dd3[,2]^2+dd3[,3]^2);
  jd1=exp(jd1);
  jd2=exp(jd2);
  jd3=exp(jd3);

  mt1=kronecker(jd1[x1]%*%t(jd2[x2]),jd3[x3]);
  mt2=kronecker(jd1[x1]%*%t(jd3[x2]),jd2[x3]);
  mt3=kronecker(jd2[x1]%*%t(jd1[x2]),jd3[x3]);
  mt4=kronecker(jd2[x1]%*%t(jd3[x2]),jd1[x3]);
  mt5=kronecker(jd3[x1]%*%t(jd2[x2]),jd1[x3]);
  mt6=kronecker(jd3[x1]%*%t(jd1[x2]),jd2[x3]);

  cr=sum(mt1==pmin(pmin(pmin(pmin(pmin(mt1, mt2), mt3), mt4), mt5), mt6)); #min of every number of mt1-mt6 is mt1

  #hypervolume under ROC manifold value
  hum=cr/(length(x1)*length(x2)*length(x3));

  result=list(call=match.call(),measure=hum,pm=pp,y=y_raw)
  class(result)="mcca.hum"

  return(result)

  }else if(num==4){

    n=length(y)
    #n is the sample size
    a=matrix(0,n,4);
    one1=a;
    one1[,1]=1;
    one2=a;
    one2[,2]=1;
    one3=a;
    one3[,3]=1;
    one4=a;
    one4[,4]=1;

    x1=which(y==1);
    x2=which(y==2);
    x3=which(y==3);
    x4=which(y==4);
    n1=sum(y==1)
    n2=sum(y==2)
    n3=sum(y==3)
    n4=sum(y==4)

    dd1=pp-one1;
    dd2=pp-one2;
    dd3=pp-one3;
    dd4=pp-one4;

    jd1=sqrt(dd1[,1]^2+dd1[,2]^2+dd1[,3]^2+dd1[,4]^2);
    jd2=sqrt(dd2[,1]^2+dd2[,2]^2+dd2[,3]^2+dd2[,4]^2);
    jd3=sqrt(dd3[,1]^2+dd3[,2]^2+dd3[,3]^2+dd3[,4]^2);
    jd4=sqrt(dd4[,1]^2+dd4[,2]^2+dd4[,3]^2+dd4[,4]^2);
    jd1=exp(jd1);
    jd2=exp(jd2);
    jd3=exp(jd3);
    jd4=exp(jd4);

    mt1=kronecker(kronecker(jd1[x1]%*%t(jd2[x2]),jd3[x3]),jd4[x4]);
    mt7=kronecker(kronecker(jd1[x1]%*%t(jd2[x2]),jd4[x3]),jd3[x4]);
    mt2=kronecker(kronecker(jd1[x1]%*%t(jd3[x2]),jd2[x3]),jd4[x4]);
    mt8=kronecker(kronecker(jd1[x1]%*%t(jd3[x2]),jd4[x3]),jd2[x4]);
    mt9=kronecker(kronecker(jd1[x1]%*%t(jd4[x2]),jd2[x3]),jd3[x4]);
    mt10=kronecker(kronecker(jd1[x1]%*%t(jd4[x2]),jd3[x3]),jd2[x4]);
    mt3=kronecker(kronecker(jd2[x1]%*%t(jd1[x2]),jd3[x3]),jd4[x4]);
    mt11=kronecker(kronecker(jd2[x1]%*%t(jd1[x2]),jd4[x3]),jd3[x4]);
    mt4=kronecker(kronecker(jd2[x1]%*%t(jd3[x2]),jd1[x3]),jd4[x4]);
    mt12=kronecker(kronecker(jd2[x1]%*%t(jd3[x2]),jd4[x3]),jd1[x4]);
    mt13=kronecker(kronecker(jd2[x1]%*%t(jd4[x2]),jd3[x3]),jd1[x4]);
    mt14=kronecker(kronecker(jd2[x1]%*%t(jd4[x2]),jd1[x3]),jd3[x4]);
    mt5=kronecker(kronecker(jd3[x1]%*%t(jd2[x2]),jd1[x3]),jd4[x4]);
    mt15=kronecker(kronecker(jd3[x1]%*%t(jd2[x2]),jd4[x3]),jd1[x4]);
    mt6=kronecker(kronecker(jd3[x1]%*%t(jd1[x2]),jd2[x3]),jd4[x4]);
    mt16=kronecker(kronecker(jd3[x1]%*%t(jd1[x2]),jd4[x3]),jd2[x4]);
    mt23=kronecker(kronecker(jd3[x1]%*%t(jd4[x2]),jd1[x3]),jd2[x4]);
    mt24=kronecker(kronecker(jd3[x1]%*%t(jd4[x2]),jd2[x3]),jd1[x4]);
    mt17=kronecker(kronecker(jd4[x1]%*%t(jd1[x2]),jd2[x3]),jd3[x4]);
    mt18=kronecker(kronecker(jd4[x1]%*%t(jd1[x2]),jd3[x3]),jd2[x4]);
    mt19=kronecker(kronecker(jd4[x1]%*%t(jd2[x2]),jd1[x3]),jd3[x4]);
    mt20=kronecker(kronecker(jd4[x1]%*%t(jd2[x2]),jd3[x3]),jd1[x4]);
    mt21=kronecker(kronecker(jd4[x1]%*%t(jd3[x2]),jd1[x3]),jd2[x4]);
    mt22=kronecker(kronecker(jd4[x1]%*%t(jd3[x2]),jd2[x3]),jd1[x4]);

    cr=sum(mt1==pmin(mt7,pmin(mt8,pmin(mt9,pmin(mt10,pmin(mt11,pmin(mt12,pmin(mt13,pmin(mt14,pmin(mt15,pmin(mt16,pmin(mt17,pmin(mt18,pmin(mt19,pmin(mt20,pmin(mt21,pmin(mt22,pmin(mt23,pmin(mt24,pmin(pmin(pmin(pmin(pmin(mt1, mt2), mt3), mt4), mt5), mt6))))))))))))))))))));


    #hypervolume under ROC manifold
    hum=cr/(n1*n2*n3*n4);

    result=list(call=match.call(),measure=hum,pm=pp,y=y_raw)
    class(result)="mcca.hum"

    return(result)

  }else if(num==2){

      x1=which(y==1) #return the label
      x2=which(y==2)
      n=length(y)

      #n is the sample size
      a=matrix(0,n,2);
      one1=a;
      one1[,1]=1;
      one2=a;
      one2[,2]=1;

      result=list(call=match.call(),measure=as.numeric(pROC::roc(y ~ pp[,1])$auc),pm=pp,y=y_raw)
      class(result)="mcca.hum"

      return(result)
      }

}

print.mcca.ccp=function(x,...){
  cat("\nCall:\n", paste(deparse(x$call), sep = "\n", collapse = "\n"),
      "\n\n", sep = "")
  cat("Overall Correct Classification Probability:\n",x$measure,"\n\n")
  cat("Category-specific Correct Classification Probability:\n")
  print(x$table)
}


print.mcca.pdi=function(x,...){
  cat("\nCall:\n", paste(deparse(x$call), sep = "\n", collapse = "\n"),
      "\n\n", sep = "")
  cat("Overall Polytomous Discrimination Index:\n",x$measure,"\n\n")
  cat("Category-specific Polytomous Discrimination Index:\n")
  print(x$table)
}

print.mcca.pdi.var=function(x,...){
  cat("\nCall:\n", paste(deparse(x$call), sep = "\n", collapse = "\n"),
      "\n\n", sep = "")
  cat("Overall Polytomous Discrimination Index:\n",x$measure,"\n\n")
  cat("Standard Error:\n",x$se,"\n\n")
  cat(paste0(x$level*100, "% Confidence Interval:\n [",
             round(x$ci[1], 4), ", ", round(x$ci[2], 4), "]\n\n"))
  cat("Category-specific Polytomous Discrimination Index:\n")
  print(x$table, row.names = FALSE)
}

print.mcca.rsq=function(x,...){
  cat("\nCall:\n", paste(deparse(x$call), sep = "\n", collapse = "\n"),
      "\n\n", sep = "")
  cat("Overall R-squared value:\n",x$measure,"\n\n")
  cat("Category-specific R-squared value:\n")
  print(x$table)
}

print.mcca.hum=function(x,...){
  cat("\nCall:\n", paste(deparse(x$call), sep = "\n", collapse = "\n"),
      "\n\n", sep = "")
  cat("Overall HUM value:\n",x$measure,"\n\n")
}

plot.mcca.hum=function(x,labs=levels(x$y),coords=1:3,nticks=5,filename='fig.png',cex=0.7,...){
  
  if (!requireNamespace("rgl", quietly = TRUE)) {
    stop(
      "Package 'rgl' is required for 3D visualization.\n",
      "Please install it with install.packages('rgl') to use plot.mcca.hum()."
    )
  }
  
  rgl_surface  <- getFromNamespace("rgl.surface", "rgl")
  rgl_bbox     <- getFromNamespace("rgl.bbox", "rgl")
  axes3d_fun   <- getFromNamespace("axes3d", "rgl")
  title3d_fun  <- getFromNamespace("title3d", "rgl")
  view3d_fun   <- getFromNamespace("view3d", "rgl")
  snapshot3d_fun <- getFromNamespace("snapshot3d", "rgl")

  n=100

  y_raw=x$y
  y=as.numeric(y_raw)

  #true positive rate for three classes
  tpP<-function(c1,c2,x) sum(x[,1]>c1 & y==1)/sum(y==1)
  tpN<-function(c1,c2,x) sum(!(x[,1]>c1) & x[,2]>c2 & y==2)/sum(y==2)
  #tpN<-function(c1,c2,x) sum(x[,2]>c2 & y==2)/sum(y==2)
  tpZ<-function(c1,c2,x) sum(!(x[,2]>c2) &! (x[,1]>c1) & y==3)/sum(y==3)

  #The outer product
  qP0<-seq(0,1,length.out=n)
  qN0<-seq(0,1,length.out=n)

  X<-outer(qP0,qN0,Vectorize(tpP,vectorize.args=c("c1","c2")),x$pm)
  Y<-outer(qP0,qN0,Vectorize(tpN,vectorize.args=c("c1","c2")),x$pm)
  Z<-outer(qP0,qN0,Vectorize(tpZ,vectorize.args=c("c1","c2")),x$pm)
  X=1-X
  Z=1-Z

  #visulization
  rgl_surface(X,Z,Y,coords = coords,color=rainbow(10)[cut(Z, breaks = 10)],
                   back = "fill",front = "fill")
  rgl_bbox(xlen=0, ylen=0, zlen=0)
  axes3d_fun(c('x','y','z'),color='white',nticks=nticks,family = "serif",cex = cex)
  title3d_fun('','',labs[coords][1],labs[coords][2],labs[coords][3],color='white',
               family = "serif",cex = cex)
  view3d_fun( theta = 210, phi = 10)
  snapshot3d_fun(filename, fmt = "png", top = TRUE)
  #rgl.viewpoint( theta = 1, phi = 15, fov = 60, zoom = 0, interactive = TRUE )
  #axes <- rbind(c(0.5, 0, 0), c(0, 0.5, 0),
  #              c(0, 0, 0.5))
  #rgl::rgl.texts(axes, text = levels(y_raw)[coords], color = "white",
  #               adj = c(-1, 0), size = 4)
}

pm <- function(y, d, method = "multinom", ...) {
  
  y_fac <- factor(y)
  y_levels <- levels(y_fac)
  y_num <- as.numeric(y_fac)
  target_levels <- as.character(seq_len(length(y_levels)))
  d <- data.matrix(d)
  
  if (method == "multinom") {
    fit <- nnet::multinom(y_fac ~ d, ...)
    predict.test.probs <- predict(fit, type = "probs")
    predict.test.df <- data.frame(predict.test.probs, check.names = FALSE)
    
    if (length(target_levels) == 2 && ncol(predict.test.df) == 1) {
      pp <- data.frame(
        "1" = 1 - predict.test.df[, 1],
        "2" = predict.test.df[, 1],
        check.names = FALSE
      )
    } else {
      old_names <- colnames(predict.test.df)
      idx <- match(old_names, y_levels)
      if (any(is.na(idx))) {
        stop("Unexpected class names returned by multinom prediction.")
      }
      colnames(predict.test.df) <- as.character(idx)
      pp <- .complete_prob_df(predict.test.df, target_levels)
    }
    
    return(pp)
  }
  
  if (method == "tree") {
    fit <- rpart::rpart(y_fac ~ d, ...)
    predict.test.probs <- predict(fit, type = "prob")
    predict.test.df <- data.frame(predict.test.probs, check.names = FALSE)
    
    old_names <- colnames(predict.test.df)
    idx <- match(old_names, y_levels)
    if (any(is.na(idx))) {
      stop("Unexpected class names returned by tree prediction.")
    }
    colnames(predict.test.df) <- as.character(idx)
    pp <- .complete_prob_df(predict.test.df, target_levels)
    
    return(pp)
  }
  
  if (method == "svm") {
    fit <- e1071::svm(y_fac ~ d, ..., probability = TRUE)
    predict.test <- predict(fit, d, probability = TRUE)
    predict.test <- attr(predict.test, "probabilities")
    predict.test.df <- data.frame(predict.test, check.names = FALSE)
    
    old_names <- colnames(predict.test.df)
    idx <- match(old_names, y_levels)
    if (any(is.na(idx))) {
      stop("Unexpected class names returned by svm prediction.")
    }
    colnames(predict.test.df) <- as.character(idx)
    pp <- .complete_prob_df(predict.test.df, target_levels)
    
    return(pp)
  }
  
  if (method == "lda") {
    fit <- MASS::lda(y_fac ~ d, ...)
    predict.test <- predict(fit)$posterior
    predict.test.df <- data.frame(predict.test, check.names = FALSE)
    
    old_names <- colnames(predict.test.df)
    idx <- match(old_names, y_levels)
    if (any(is.na(idx))) {
      stop("Unexpected class names returned by lda prediction.")
    }
    colnames(predict.test.df) <- as.character(idx)
    pp <- .complete_prob_df(predict.test.df, target_levels)
    
    return(pp)
  }
  
  if (method == "prob") {
    pp_sum <- rowSums(d)
    if (any(pp_sum < 0.999 | pp_sum > 1.001)) {
      cat("ERROR: The input value \"d\" should be a probability matrix.")
      return(NULL)
    }
    pp <- d
    return(pp)
  }
  
  stop("Unsupported method.")
}




.complete_prob_df <- function(prob, target_levels) {
  prob <- as.data.frame(prob, check.names = FALSE)
  
  out <- as.data.frame(
    matrix(0, nrow = nrow(prob), ncol = length(target_levels)),
    check.names = FALSE
  )
  colnames(out) <- target_levels
  
  common <- intersect(colnames(prob), target_levels)
  if (length(common) > 0) {
    out[, common] <- prob[, common, drop = FALSE]
  }
  
  out
}

rsq=function(y,d,method="multinom",...){

  y=factor(y)
  y_levels=levels(y)
  y=as.numeric(y)
  d=data.matrix(d)
  num=length(unique(y))

  pp=pm(y=y,d=d,method=method,...)

  #########################################
  if(num==3){

    n1=sum(y==1)
    n2=sum(y==2)
    n3=sum(y==3)
    nn=n1+n2+n3
    ro1=n1/nn
    ro2=n2/nn
    ro3=n3/nn

    rsq=(
      stats::var(pp[,1])/(ro1*(1-ro1))+
        stats::var(pp[,2])/(ro2*(1-ro2))+
        stats::var(pp[,3])/(ro3*(1-ro3))
    )/3/nn*(nn-1)

    rsqs=c(stats::var(pp[,1])/(ro1*(1-ro1)),stats::var(pp[,2])/(ro2*(1-ro2)),stats::var(pp[,3])/(ro3*(1-ro3)))/nn*(nn-1)

    df=data.frame(CATEGORIES=sapply(1:num, function(i) y_levels[i]),VALUES=rsqs)
    result=list(call=match.call(),measure=rsq,table=df)
    class(result)="mcca.rsq"
    return(result)


  }else if(num==4){

    n1=sum(y==1)
    n2=sum(y==2)
    n3=sum(y==3)
    n4=sum(y==4)
    nn=n1+n2+n3+n4
    ro1=n1/nn
    ro2=n2/nn
    ro3=n3/nn
    ro4=n4/nn

    rsq=(stats::var(pp[,1])/(ro1*(1-ro1))+stats::var(pp[,2])/(ro2*(1-ro2))+stats::var(pp[,3])/(ro3*(1-ro3))+stats::var(pp[,4])/(ro4*(1-ro4)))/4/nn*(nn-1)

    rsqs=c(stats::var(pp[,1])/(ro1*(1-ro1)),stats::var(pp[,2])/(ro2*(1-ro2)),stats::var(pp[,3])/(ro3*(1-ro3)),stats::var(pp[,4])/(ro4*(1-ro4)))/nn*(nn-1)

    df=data.frame(CATEGORIES=sapply(1:num, function(i) y_levels[i]),VALUES=rsqs)
    result=list(call=match.call(),measure=rsq,table=df)
    class(result)="mcca.rsq"
    return(result)



  }else if(num==2){
    n1=sum(y==1)
    n2=sum(y==2)

    nn=n1+n2
    ro1=n1/nn
    ro2=n2/nn


    rsq=(stats::var(pp[,1])/(ro1*(1-ro1))+stats::var(pp[,2])/(ro2*(1-ro2)))/2/nn*(nn-1)
    rsqs=c(stats::var(pp[,1])/(ro1*(1-ro1)),stats::var(pp[,2])/(ro2*(1-ro2)))/nn*(nn-1)

    df=data.frame(CATEGORIES=sapply(1:num, function(i) y_levels[i]),VALUES=rsqs)
    result=list(call=match.call(),measure=rsq,table=df)
    class(result)="mcca.rsq"
    return(result)  }
}

idi=function(y,m1,m2,method="multinom",...){
  if (method!="prob"){
    rsq1=rsq(y=y,d=m1,method=method,...)$measure
    rsq2=rsq(y=y,d=cbind(m1,m2),method=method,...)$measure
  }else{
    rsq1=rsq(y=y,d=m1,method=method,...)$measure
    rsq2=rsq(y=y,d=m2,method=method,...)$measure
  }
  return(rsq2-rsq1)

}

ests <- function (y, d, acc="hum",level=0.95,method = "multinom",B=250,balance=FALSE, ...) {

  series=numeric()
  k=length(unique(y))

  if (acc=="hum"){

    if (balance==FALSE){
    for (b in 1:B){
      nn <- length(y)
      id <- sample(1:nn,nn,replace = T)
      #id <- unique(id)
      while (length(unique(y[id]))<k){
        id <- sample(1:nn,nn,replace = T)
        #id <- unique(id)
      }
      while (min(table(y[id]))<2){
        id <- sample(1:nn,nn,replace = T)
        #id <- unique(id)
      }
      if ("numeric" %in% class(d)){
      series[b] <- hum(y=y[id],d=d[id],method=method,...)$measure
      }else {
        series[b] <- hum(y=y[id],d=d[id,],method=method,...)$measure
      }
    }
    }
    if (balance==TRUE){
      for (b in 1:B){
        id <- unlist(caret::createResample(y, times = 1))
        if ("numeric" %in% class(d)){
          series[b] <- hum(y=y[id],d=d[id],method=method,...)$measure
        }else {
          series[b] <- hum(y=y[id],d=d[id,],method=method,...)$measure
        }
      }
    }

    series.sort <- sort(series)
    return(list(value=hum(y=y,d=d,method=method,...)$measure,
                se=sd(series),
                interval=c(series.sort[ifelse(B*(0.5-level/2)<1,1,B*(0.5-level/2))],series.sort[B*(0.5+level/2)])))
  }
  if (acc=="pdi"){
    if (balance==FALSE){
    for (b in 1:B){
      nn <- length(y)
      id <- sample(1:nn,nn,replace = T)
      #id <- unique(id)
      while (length(unique(y[id]))<k){
        id <- sample(1:nn,nn,replace = T)
        #id <- unique(id)
      }
      while (min(table(y[id]))<2){
        id <- sample(1:nn,nn,replace = T)
        #id <- unique(id)
      }
      if ("numeric" %in% class(d)){
        series[b] <- pdi(y=y[id],d=d[id],method=method,...)$measure
      }else {
        series[b] <- pdi(y=y[id],d=d[id,],method=method,...)$measure
      }
    }
    }
    if (balance==TRUE){
      for (b in 1:B){
        id <- unlist(caret::createResample(y, times = 1))
        if ("numeric" %in% class(d)){
          series[b] <- pdi(y=y[id],d=d[id],method=method,...)$measure
        }else {
          series[b] <- pdi(y=y[id],d=d[id,],method=method,...)$measure
        }
      }
    }
    series.sort <- sort(series)
    return(list(value=pdi(y=y,d=d,method=method,...)$measure,
                se=sd(series),
                interval=c(series.sort[ifelse(B*(0.5-level/2)<1,1,B*(0.5-level/2))],series.sort[B*(0.5+level/2)])))
  }
  if (acc=="ccp"){
    if (balance==FALSE){
    for (b in 1:B){
      nn <- length(y)
      id <- sample(1:nn,nn,replace = T)
      #id <- unique(id)
      while (length(unique(y[id]))<k){
        id <- sample(1:nn,nn,replace = T)
        #id <- unique(id)
      }
      while (min(table(y[id]))<2){
        id <- sample(1:nn,nn,replace = T)
        #id <- unique(id)
      }
      if ("numeric" %in% class(d)){
        series[b] <- ccp(y=y[id],d=d[id],method=method,...)$measure
      }else {
        series[b] <- ccp(y=y[id],d=d[id,],method=method,...)$measure
      }
    }
  }
  if (balance==TRUE){
    for (b in 1:B){
      id <- unlist(caret::createResample(y, times = 1))
      if ("numeric" %in% class(d)){
        series[b] <- ccp(y=y[id],d=d[id],method=method,...)$measure
      }else {
        series[b] <- ccp(y=y[id],d=d[id,],method=method,...)$measure
      }
    }
  }
    series.sort <- sort(series)
    return(list(value=ccp(y=y,d=d,method=method,...)$measure,
                se=sd(series),
                interval=c(series.sort[ifelse(B*(0.5-level/2)<1,1,B*(0.5-level/2))],series.sort[B*(0.5+level/2)])))
  }

  if (acc=="rsq"){
    if (balance==FALSE){
    for (b in 1:B){
      nn <- length(y)
      id <- sample(1:nn,nn,replace = T)
      #id <- unique(id)
      while (length(unique(y[id]))<k){
        id <- sample(1:nn,nn,replace = T)
        #id <- unique(id)
      }
      while (min(table(y[id]))<2){
        id <- sample(1:nn,nn,replace = T)
        #id <- unique(id)
      }
      if ("numeric" %in% class(d)){
        series[b] <- rsq(y=y[id],d=d[id],method=method,...)$measure
      }else {
        series[b] <- rsq(y=y[id],d=d[id,],method=method,...)$measure
      }
    }
  }
if (balance==TRUE){
  for (b in 1:B){
    id <- unlist(caret::createResample(y, times = 1))
    if ("numeric" %in% class(d)){
      series[b] <- rsq(y=y[id],d=d[id],method=method,...)$measure
    }else {
      series[b] <- rsq(y=y[id],d=d[id,],method=method,...)$measure
    }
  }
}
    series.sort <- sort(series)
    return(list(value=rsq(y=y,d=d,method=method,...)$measure,
                se=sd(series),
                interval=c(series.sort[ifelse(B*(0.5-level/2)<1,1,B*(0.5-level/2))],series.sort[B*(0.5+level/2)])))
  }

}

\name{pm}
\alias{pm}
\title{Calculate Probability Matrix}
\usage{
pm(y, d, method="multinom", \dots)
}
\description{
compute the probability matrix of two or three or four categories classifiers with an option to define the specific model or user-defined model.
}
\arguments{
  \item{y}{The multinomial response vector with two, three or four categories. It can be factor or integer-valued.}
  \item{d}{The set of candidate markers, including one or more columns. Can be a data frame or a matrix.}
  \item{method}{Specifies what method is used to construct the classifier based on the marker set in d. Available option includes the following methods:"multinom": Multinomial Logistic Regression which is the default method, requiring R package nnet;"tree": Classification Tree method, requiring R package rpart;"svm": Support Vector Machine (C-classification and radial basis as default), requiring R package e1071;"lda": Linear Discriminant Analysis, requiring R package lda.}
  \item{\dots}{Additional arguments in the chosen method's function.}
}
\details{
The function returns the probability matrix for predictive markers based on a user-chosen machine learning method. Currently available methods include logistic regression (default), tree, lda, svm and user-computed risk values.

}
\value{
The probability matrix of the classification using a particular learning method on a set of marker(s).
}
\references{
Li, J. and Fine, J. P. (2008): ROC analysis with multiple tests and multiple classes: methodology and applications in microarray studies. Biostatistics. 9 (3): 566-576.

Li, J., Chow, Y., Wong, W.K., and Wong, T.Y. (2014). Sorting Multiple Classes in Multi-dimensional ROC Analysis: Parametric and Nonparametric Approaches. Biomarkers. 19(1): 1-8.
}
\author{
Ming Gao: gaoming@umich.edu

Pan Liu: pan.liu@nus.edu.sg

Jialiang Li: stalj@nus.edu.sg
}

\seealso{
\code{\link{pdi}}
}
\examples{
str(iris)
data <- iris[, 1:4]
label <- iris[, 5]
pm(y = label, d = data,method = "multinom")

}
\keyword{ PM }

\name{estp}
\alias{estp}
\title{Inference for Accuracy Improvement Measures based on Bootstrap}
\usage{
estp(y, m1, m2, acc="idi", level=0.95, method="multinom", B=250, balance=FALSE, \dots)
}
\description{
compute the bootstrap standard error and confidence interval for the classification accuracy improvement for a pair of nested models.
}
\arguments{
  \item{y}{The multinomial response vector with two, three or four categories. It can be factor or integer-valued.}
  \item{m1}{The set of marker(s) included in the baseline model, can be a data frame or a matrix; if the method is "prob", then m1 should be the prediction probablity matrix of the baseline model.}
  \item{m2}{The set of additional marker(s) included in the improved model, can be a data frame or a matrix; if the method is "prob", then m2 should be the prediction probablity matrix of the improved model.}
  \item{acc}{Accuracy measure to be evaluated. Allow two choices: "idi", "nri".}
  \item{level}{The confidence level. Default value is 0.95.}
  \item{method}{Specifies what method is used to construct the classifier based on the marker set in m1 & m2. Available option includes the following methods:"multinom": Multinomial Logistic Regression which is the default method, requiring R package nnet;"tree": Classification Tree method, requiring R package rpart;"svm": Support Vector Machine (C-classification and radial basis as default), requiring R package e1071;"lda": Linear Discriminant Analysis, requiring R package lda;"prob": m1 & m2 are risk matrices resulted from any external classification algorithm obtained by the user.}
  \item{B}{Number of bootstrap resamples.}
  \item{balance}{Logical, if TRUE, the class prevalence of the bootstrap sample is forced to be identical to the class prevalence of the original sample. Otherwise the prevalence of the bootstrap sample may be random.}
  \item{\dots}{Additional arguments in the chosen method's function.}
}
\details{
The function returns the standard error and confidence interval for a paired model evaluation method. All the other arguments are the same as the function \code{\link{hum}}.

}
\value{
\item{value}{The specific value of the classification using a particular learning method on a set of marker(s).}
\item{se}{The standard error of the value.}
\item{interval}{The confidence interval of the value.}
}

\author{
Ming Gao: gaoming@umich.edu

Pan Liu: pan.liu@nus.edu.sg

Jialiang Li: stalj@nus.edu.sg
}
\note{
Users are advised to change the operating settings of various classifiers since it is well known that machine learning methods require extensive tuning. Currently only some common and intuitive options are set as default and they are by no means the optimal parameterization for a particular data analysis. Users can put machine learning methods' parameters after tuning. A more flexible evaluation is to consider "method=prob" in which case the input m1 & m2 should be a matrix of membership probabilities with k columns and each row of m1 & m2 should sum to one.

}
\seealso{
\code{\link{ests}}
}
\examples{
table(mtcars$carb)
for (i in (1:length(mtcars$carb))) {
  if (mtcars$carb[i] == 3 | mtcars$carb[i] == 6 | mtcars$carb[i] == 8) {
    mtcars$carb_new[i] = 9
  }else{
    mtcars$carb_new[i] = mtcars$carb[i]
  }
}
data <- data.matrix(mtcars[, c(1,2)])
mtcars$carb_new <- factor(mtcars$carb_new)
label <- mtcars$carb_new
str(mtcars)
estp(y = label, m1 = data[, 1], m2 = data[, 2], acc="idi",method="lda", B=10)

## $value
## [1] 0.1235644

## $se
## [1] 0.07053541

## $interval
## [1] 0.05298885 0.21915088

estp(y = label, m1 = data[, 1], m2 = data[, 2], acc="nri",method="tree",B=5)

## $value
## [1] 0.05

## $se
## [1] 0.09249111

## $interval
## [1] 0.0000000  0.1458333

}
\keyword{ IDI }

\name{print.mcca.hum}
\alias{print.mcca.hum}
\title{Print Method for mcca hum class}
\usage{
\method{print}{mcca.hum}(x, ...)
}
\description{
An S3 method for the print generic. It is designed for a quick look at hum values.
}
\arguments{
  \item{x}{object of class `mcca.hum`.}
  \item{\dots}{further arguments to `print.default`.}
}

\value{
An object of class "mcca.hum" is a list containing at least the following components:
  \item{call}{the matched call.}
  \item{measure}{the value of measure.}
  \item{table}{the category-specific value of measure.}
}
\references{
Li, J., Jiang, B. and Fine, J. P. (2013). Multicategory reclassification statistics for assessing Improvements in diagnostic accuracy. Biostatistics. 14(2): 382-394.

Li, J., Jiang, B., and Fine, J. P. (2013). Letter to Editor: Response. Biostatistics. 14(4): 809-810.
}
\author{
Ming Gao: gaoming@umich.edu

Pan Liu: pan.liu@nus.edu.sg

Jialiang Li: stalj@nus.edu.sg
}

\examples{
data = iris[, 1:4]
label = iris[, 5]
hum_object=hum(y = label, d = data, method = "multinom",maxit = 1000,MaxNWts = 2000,trace=FALSE)
print(hum_object)

}
\keyword{ hum }

\name{pdi}
\alias{pdi}
\title{Calculate PDI Value}
\usage{
pdi(y, d, method="multinom", withTies = TRUE, Var = FALSE, level = 0.95, \dots)
}
\description{
compute the Polytomous Discrimination Index (PDI) value for a classifier, with optional variance estimation, using either a specified built-in classification method or user-supplied class probabilities.
}
\arguments{
  \item{y}{A multinomial response vector with two or more categories. It can be a factor or an integer-valued vector.}
  \item{d}{A set of candidate markers with one or more columns. It can be a data frame or a matrix. If \code{method = "prob"}, then \code{d} should be a matrix of predicted class probabilities.}
  \item{method}{The method used to construct the classifier based on the marker set in \code{d}. Available options are \code{"multinom"} (multinomial logistic regression; default; requires package \pkg{nnet}), \code{"tree"} (classification tree; requires package \pkg{rpart}), \code{"svm"} (support vector machine classification; requires package \pkg{e1071}), \code{"lda"} (linear discriminant analysis; requires package \pkg{MASS}), and \code{"prob"} (user-supplied predicted class probabilities).}
  \item{withTies}{A logical value indicating whether tied predicted probabilities may occur in the PDI calculation. This argument is only used when \code{Var = TRUE}. The default is \code{TRUE}.}
  \item{Var}{A logical value indicating whether to compute the variance and confidence interval of the PDI. The default is \code{FALSE}.}
  \item{level}{The confidence level for confidence interval construction. The default is \code{0.95}.}
  \item{\dots}{Additional arguments passed to the function corresponding to the chosen classification method.}
}
\details{
The function returns the PDI value for predictive markers based on a user-chosen machine learning method. Currently available methods include logistic regression (default), tree, lda, svm and user-computed risk values. This function is general since we can evaluate the accuracy for marker combinations resulted from complicated classification algorithms.


}
\value{
Returns an object of class \code{"mcca.pdi"}. The PDI value of the classifier obtained using a particular learning method on a set of marker(s).

An object of class \code{"mcca.pdi"} is a list containing at least the following components:
  \item{call}{the matched call.}
  \item{measure}{the value of the PDI.}
  \item{table}{the category-specific values of the PDI.}
If \code{Var = TRUE}, the list also contains the following:
  \item{se}{the calculated standard error of the overall PDI.}
  \item{ci}{the confidence interval for the overall PDI.}
  \item{level}{the confidence level used.}
and component \code{table} also contains the standard errors and confidence intervals of the category-specific PDI values.
}
\references{
Feng, Q., Jia, T., Liu, P., Van Calster, B., Li J. (2026). Efficient variance estimation for the polytomous discrimination index. Statistics in Medicine.

Dover, D.C., Savu, A., Engel, B. (2021). Polytomous discrimination index: Estimation and inference. Statistics in Medicine.

Li, J., Gao, M., D’Agostino, R. (2019). Evaluating Classification Accuracy for Modern Learning Approaches. Statistics in Medicine (Tutorials in Biostatistics). 38(13): 2477-2503.

Van Calster, B., Vergouwe, Y., Looman, C.W.N., Van Belle, V., Timmerman, D. and Steyerberg, E.W. Assessing the discriminative ability of risk models for more than two outcome categories. European Journal of Epidemiology 2012; 27: 761-770.

Li, J., Feng, Q., Fine, J.P., Pencina, M.J., Van Calster, B. (2018). Nonparametric estimation and inference for polytomous discrimination index. Statistical Methods in Medical Research. 27(10): 3092—3103.
}
\author{
Ming Gao: gaoming@umich.edu

Pan Liu: pan.liu@nus.edu.sg

Jialiang Li: stalj@nus.edu.sg
}
\note{
Users are advised to change the operating settings of various classifiers since it is well known that machine learning methods require extensive tuning. Currently only some common and intuitive options are set as default and they are by no means the optimal parameterization for a particular data analysis. Users can put machine learning methods' parameters after tuning. A more flexible evaluation is to consider "method=prob" in which case the input d should be a matrix of membership probabilities with k columns and each row of d should sum to one.
}
\seealso{
\code{\link{hum}}
}
\examples{
str(iris)
data <- iris[, 3]
label <- iris[, 5]
pdi(y = label, d = data,method = "multinom")

## Call:
## pdi(y = label, d = data, method = "multinom")

## Overall Polytomous Discrimination Index:
##  0.9881333

## Category-specific Polytomous Discrimination Index:
##    CATEGORIES VALUES
##  1     setosa 1.0000
##  2 versicolor 0.9822
##  3  virginica 0.9822

# PDI with variance estimation
pdi(y = label, d = data, method = "multinom", Var = TRUE)

## Call:
## pdi(y = label, d = data, method = "multinom", Var = TRUE)

## Overall Polytomous Discrimination Index:
##  0.9881333

## Standard Error:
##  0.006440373

## 95\% Confidence Interval:
##  [0.9755104, 1.0000000]

## Category-specific Polytomous Discrimination Index:
##  CATEGORIES VALUES     SE LOWER_CI UPPER_CI
##      setosa 1.0000 0.0000   1.0000   1.0000
##  versicolor 0.9822 0.0097   0.9633   1.0000
##   virginica 0.9822 0.0097   0.9633   1.0000

pdi(y = label, d = data,method = "tree")
pdi(y = label, d = data,method = "tree",control = rpart::rpart.control(minsplit = 200))

data <- data.matrix(iris[, 3])
label <- as.numeric(iris[, 5])
# multinomial
require(nnet)
# model
fit <- multinom(label ~ data, maxit = 1000, MaxNWts = 2000)
predict.probs <- predict(fit, type = "probs")
pp<- data.frame(predict.probs)
# extract the probablity assessment vector
head(pp)
pdi(y = label, d = pp, method = "prob")
}
\keyword{ PDI }

\name{mcca-package}
\alias{mcca-package}
\alias{mcca}
\docType{package}
\title{
Diagnostic accuracy methods for classifiers
}
\description{
  Six common multi-category classification accuracy evaluation measures are included i.e., Correct Classification Percentage (CCP), Hypervolume Under Manifold (HUM), Integrated Discrimination Improvement (IDI), Net Reclassification Improvement (NRI), Polytomous Discrimination Index (PDI) and R-squared (RSQ). It allows users to fit many popular classification procedures, such
as multinomial logistic regression, support vector machine, classification tree, and user computed
risk values. Additionally, PDI with variance estimation using Dover et al. (2021) method is provided via the pdi function.

}
\details{
\tabular{ll}{
Package: \tab mcca\cr
Type: \tab Package\cr
Version: \tab 0.8.2\cr
Date: \tab 2026-04-12\cr
License: \tab GPL\cr
}

}
\section{Functions}{
  \tabular{ll}{
    \code{\link{ccp}} \tab Calculate CCP Value \cr
    \code{\link{hum}} \tab Calculate HUM Value \cr
    \code{\link{plot.mcca.hum}} \tab Plot 3D ROC curve \cr
    \code{\link{idi}} \tab Calculate IDI Value \cr
    \code{\link{nri}} \tab Calculate NRI Value \cr
    \code{\link{pdi}} \tab Calculate PDI Value with Optional Variance Estimation \cr
    \code{\link{rsq}} \tab Calculate RSQ Value \cr
    \code{\link{pm}} \tab Calculate Probability Matrix \cr
    \code{\link{ests}} \tab Estimated Information for Single Model Evaluation Value \cr
    \code{\link{estp}} \tab Estimated Information for Paired Model Evaluation Value \cr

  }
}

\section{Installing and using}{
  To install this package, make sure you are connected to the internet and issue the following command in the R prompt:

  \preformatted{
    install.packages("mcca")
  }

  To load the package in R:

  \preformatted{
    library(mcca)
  }
}

\section{Citation}{
Li J, Gao M, D'Agostino R. Evaluating classification accuracy for modern learning
approaches. Statistics in Medicine. 2019;1-27. https://doi.org/10.1002/sim.8103
}
\author{
Ming Gao, Pan Liu, Jialiang Li

Maintainer: Jialiang Li <stalj@nus.edu.sg>
}
\references{
Li, J., Gao, M., D’Agostino, R. (2019). Evaluating Classification Accuracy for Modern Learning Approaches. Statistics in Medicine (Tutorials in Biostatistics). 38(13): 2477-2503.

Li, Ming G., D'Agostino. (2019). Evaluating Classification Accuracy for Modern Learning Approaches. Statistics in Medicine.

Li, J. and Fine, J. P. (2008): ROC analysis with multiple tests and multiple classes: methodology and applications in microarray studies. Biostatistics. 9 (3): 566-576.

Li, J., Chow, Y., Wong, W.K., and Wong, T.Y. (2014). Sorting Multiple Classes in Multi-dimensional ROC Analysis: Parametric and Nonparametric Approaches. Biomarkers. 19(1): 1-8.

Li, J., Jiang, B. and Fine, J. P. (2013). Multicategory reclassification statistics for assessing Improvements in diagnostic accuracy. Biostatistics. 14(2): 382-394.

Li, J., Jiang, B., and Fine, J. P. (2013). Letter to Editor: Response. Biostatistics. 14(4): 809-810.

Feng, Q., Jia, T., Liu, P., Van Calster, B., Li J. (2026). Efficient variance estimation for the polytomous discrimination index. Statistics in Medicine.

Van Calster, B., Vergouwe, Y., Looman, C.W.N., Van Belle, V., Timmerman, D. and Steyerberg, E.W. Assessing the discriminative ability of risk models for more than two outcome categories. European Journal of Epidemiology 2012; 27: 761-770.

Li, J., Feng, Q., Fine, J.P., Pencina, M.J., Van Calster, B. (2018). Nonparametric estimation and inference for polytomous discrimination index. Statistical Methods in Medical Research. 27(10): 3092—3103.

}

\keyword{CCP}
\keyword{HUM}
\keyword{IDI}


\seealso{
CRAN packages \pkg{HUM} for HUM.

CRAN packages \pkg{nnet}, \pkg{rpart}, \pkg{e1071},  \pkg{MASS} employed in this package.
}
\examples{

str(iris)
data <- iris[, 1:4]
label <- iris[, 5]
ccp(y = label, d = data, method = "multinom",maxit = 1000,MaxNWts = 2000,trace=FALSE)
ccp(y = label, d = data, method = "multinom")
ccp(y = label, d = data, method = "svm")
ccp(y = label, d = data, method = "svm",kernel="sigmoid",cost=4,scale=TRUE,coef0=0.5)
ccp(y = label, d = data, method = "tree")
p = as.numeric(label)
ccp(y = label, d = p, method = "label")
hum(y = label, d = data,method = "multinom")
hum(y = label, d = data,method = "svm")
hum(y = label, d = data,method = "svm",kernel="linear",cost=4,scale=TRUE)
hum(y = label, d = data, method = "tree")
\donttest{ests(y = label, d = data,acc="hum",level=0.95,method = "multinom",trace=FALSE)}

## $value
## [1] 0.9972

## $sd
## [1] 0.002051529

## $interval
## [1] 0.9935662 1.0000000
}

\name{nri}
\alias{nri}
\title{Calculate NRI Value}
\usage{
nri(y, m1, m2, method="multinom", \dots)
}
\description{
compute the net reclassification improvement (NRI) value of two or three or four categories classifiers with an option to define the specific model or user-defined model.
}
\arguments{
  \item{y}{The multinomial response vector with two, three or four categories. It can be factor or integer-valued.}
  \item{m1}{The set of marker(s) included in the baseline model, can be a data frame or a matrix; if the method is "prob", then m1 should be the prediction probablity matrix of the baseline model.}
  \item{m2}{The set of additional marker(s) included in the improved model, can be a data frame or a matrix; if the method is "prob", then m2 should be the prediction probablity matrix of the improved model.}
  \item{method}{Specifies what method is used to construct the classifier based on the marker set in m1 & m2. Available option includes the following methods:"multinom": Multinomial Logistic Regression which is the default method, requiring R package nnet;"tree": Classification Tree method, requiring R package rpart;"svm": Support Vector Machine (C-classification and radial basis as default), requiring R package e1071;"lda": Linear Discriminant Analysis, requiring R package lda;"label": m1 & m2 are label vectors resulted from any external classification algorithm obtained by the user;"prob": m1 & m2 are probability matrices resulted from any external classification algorithm obtained by the user.}
  \item{\dots}{Additional arguments in the chosen method's function.}
}
\details{
The function returns the NRI value for predictive markers based on a user-chosen machine learning method. Currently available methods include logistic regression (default), tree, lda, svm and user-computed risk values. This function is general since we can evaluate the accuracy for marker combinations resulted from complicated classification algorithms.

}
\value{
The NRI value of the classification using a particular learning method on a set of marker(s).
}
\references{
Li, J., Gao, M., D’Agostino, R. (2019). Evaluating Classification Accuracy for Modern Learning Approaches. Statistics in Medicine (Tutorials in Biostatistics). 38(13): 2477-2503.

Li, J., Jiang, B. and Fine, J. P. (2013). Multicategory reclassification statistics for assessing Improvements in diagnostic accuracy. Biostatistics. 14(2): 382—394.

Li, J., Jiang, B., and Fine, J. P. (2013). Letter to Editor: Response. Biostatistics. 14(4): 809-810.
}
\author{
Ming Gao: gaoming@umich.edu

Pan Liu: pan.liu@nus.edu.sg

Jialiang Li: stalj@nus.edu.sg
}
\note{
Users are advised to change the operating settings of various classifiers since it is well known that machine learning methods require extensive tuning. Currently only some common and intuitive options are set as default and they are by no means the optimal parameterization for a particular data analysis. Users can put machine learning methods' parameters after tuning. A more flexible evaluation is to consider "method=prob" in which case the input m1 & m2 should be a matrix of membership probabilities with k columns and each row of m1 & m2 should sum to one.
}
\seealso{
\code{\link{idi}}
}
\examples{
table(mtcars$carb)
for (i in (1:length(mtcars$carb))) {
  if (mtcars$carb[i] == 3 | mtcars$carb[i] == 6 | mtcars$carb[i] == 8) {
    mtcars$carb_new[i] = 9
  }else{
    mtcars$carb_new[i] = mtcars$carb[i]
  }
}
data <- data.matrix(mtcars[, c(1,5)])
mtcars$carb_new <- factor(mtcars$carb_new)
label <- mtcars$carb_new
str(mtcars)

nri(y = label, m1 = data[, 1], m2 = data[, 2], "lda")
## [1] 0.09375
nri(y = label, m1 = data[, 1], m2 = data[, 2], "tree")
## [1] 0.0625
nri(y = label, m1 = data[, 1], m2 = data[, 2], "tree",control=rpart::rpart.control(minsplit=4))
## [1] 0.1875
}
\keyword{ NRI }

\name{plot.mcca.hum}
\alias{plot.mcca.hum}
\title{Plot 3D ROC surface}
\usage{
\method{plot}{mcca.hum}(x,labs=levels(x$y),coords=1:3,nticks=5,filename='fig.png',cex=0.7, \dots)
}
\description{
plot the 3D ROC surface for a three-category classifier using the 3-dimensional point coordinates, computed by obj which is a mcca.hum class.
}
\arguments{
  \item{x}{An mcca.hum class object, containing probability matrix and labels.}
  \item{labs}{The label names of three coordinates. Default is `levels(x$y)`.}
  \item{coords}{The coordinates markers. Default is `c(1,2,3)`, which means labs[1] is the x-axis (class 1), labs[2] is the z-axis (class 3) and labs[3] is the y-axis (class 2).}
  \item{nticks}{Suggested number of ticks.}
  \item{filename}{Filename to save snapshot.}
  \item{cex}{Size for text.}
  \item{\dots}{further arguments to `plot.default`.}
}
\details{
This function is to plot the 3D ROC surface according to the correct classification probabilities for the three categories, resulted from any statistical or machine learning methods. This function complements the HUM package which can only plot 3D ROC surface for a single diagnostic test or biomarker for three classes.

}
\value{
The function doesn't return any value.
}
\references{
Li, J., and Zhou, X. H. (2009). Nonparametric and semiparametric estimation of the three way receiver operating characteristic surface. Journal of Statistical Planning and Inference. 139: 4133—4142.

Li, J., Gao, M., D’Agostino, R. (2019). Evaluating Classification Accuracy for Modern Learning Approaches. Statistics in Medicine (Tutorials in Biostatistics). 38(13): 2477-2503.
}
\author{
Ming Gao: gaoming@umich.edu

Pan Liu: pan.liu@nus.edu.sg

Jialiang Li: stalj@nus.edu.sg
}

\examples{
data <- iris[, 1]
label <- iris[, 5]
a=hum(y = label, d = data,method = "multinom")
#plot(a,filename='fig.png')

}
\keyword{ Plot }

\name{ests}
\alias{ests}
\title{Inference for Accuracy Measures based on Bootstrap}
\usage{
ests(y, d, acc="hum", level=0.95, method="multinom", B=250, balance=FALSE, \dots)
}
\description{
compute the bootstrap standard error and confidence interval for the classification accuracy for a single classification model.
}
\arguments{
  \item{y}{The multinomial response vector with two, three or four categories. It can be factor or integer-valued.}
  \item{d}{The set of candidate markers, including one or more columns. Can be a data frame or a matrix; if the method is "prob", then d should be the probability matrix.}
  \item{acc}{Accuracy measure to be evaluated. Allow four choices: "hum", "pdi", "ccp" and "rsq".}
  \item{level}{The confidence level. Default value is 0.95.}
  \item{method}{Specifies what method is used to construct the classifier based on the marker set in d. Available option includes the following methods:"multinom": Multinomial Logistic Regression which is the default method, requiring R package nnet;"tree": Classification Tree method, requiring R package rpart; "svm": Support Vector Machine (C-classification and radial basis as default), requiring R package e1071; "lda": Linear Discriminant Analysis, requiring R package lda; "label": d is a label vector resulted from any external classification algorithm obtained by the user, should be encoded from 1; "prob": d is a probability matrix resulted from any external classification algorithm obtained by the user.}
  \item{B}{Number of bootstrap resamples.}
  \item{balance}{Logical, if TRUE, the class prevalence of the bootstrap sample is forced to be identical to the class prevalence of the original sample. Otherwise the prevalence of the bootstrap sample may be random.}
  \item{\dots}{Additional arguments in the chosen method's function.}
}
\details{
The function returns the standard error and confidence interval for a single model evaluation method. All the other arguments are the same as the function \code{\link{hum}}.

}
\value{
\item{value}{The specific value of the classification using a particular learning method on a set of marker(s).}
\item{se}{The standard error of the value.}
\item{interval}{The confidence interval of the value.}

}
\author{
Ming Gao: gaoming@umich.edu

Pan Liu: pan.liu@nus.edu.sg

Jialiang Li: stalj@nus.edu.sg
}
\note{
Users are advised to change the operating settings of various classifiers since it is well known that machine learning methods require extensive tuning. Currently only some common and intuitive options are set as default and they are by no means the optimal parameterization for a particular data analysis. Users can put machine learning methods' parameters after tuning. A more flexible evaluation is to consider "method=prob" in which case the input d should be a matrix of membership probabilities with k columns and each row of d should sum to one.


}
\seealso{
\code{\link{estp}}
}
\examples{
str(iris)
data <- iris[, 1:4]
label <- iris[, 5]
ests(y = label, d = data,acc="hum",level=0.95,method = "multinom",B=10,trace=FALSE)

## $value
## [1] 0.9972

## $se
## [1] 0.002051529

## $interval
## [1] 0.9935662 1.0000000

ests(y = label, d = data,acc="pdi",level=0.85,method = "tree",B=10)

## $value
## [1] 0.9213333

## $se
## [1] 0.02148812

## $interval
## [1] 0.9019608 0.9629630

table(mtcars$carb)
for (i in (1:length(mtcars$carb))) {
  if (mtcars$carb[i] == 3 | mtcars$carb[i] == 6 | mtcars$carb[i] == 8) {
    mtcars$carb_new[i] = 9
  }else{
    mtcars$carb_new[i] = mtcars$carb[i]
  }
}
data <- data.matrix(mtcars[, c(1:2)])
mtcars$carb_new <- factor(mtcars$carb_new)
label <- mtcars$carb_new
str(mtcars)

ests(y = label, d = data,acc="hum",level=0.95,method = "multinom",trace=FALSE,B=5)

## $value
## [1] 0.2822857

## $se
## [1] 0.170327

## $interval
## [1] 0.2662500 0.4494643

}
\keyword{ CCR }

\name{ccp}
\alias{ccp}
\title{Calculate CCP Value}
\usage{
ccp(y, d, method="multinom", \dots)
}
\description{
compute the Correct Classification Percentage (CCP) value of two or three or four categories classifiers with an option to define the specific model or user-defined model.
}
\arguments{
  \item{y}{The multinomial response vector with two, three or four categories.}
  \item{d}{The set of candidate markers, including one or more columns. Can be a data frame or a matrix; if the method is "label", then d should be the label vector.}
  \item{method}{Specifies what method is used to construct the classifier based on the marker set in d. Available option includes the following methods:"multinom": Multinomial Logistic Regression which is the default method, requiring R package nnet;"tree": Classification Tree method, requiring R package rpart; "svm": Support Vector Machine (C-classification and radial basis as default), requiring R package e1071; "lda": Linear Discriminant Analysis, requiring R package lda; "label": d is a label vector resulted from any external classification algorithm obtained by the user, should be encoded from 1; "prob": d is a probability matrix resulted from any external classification algorithm obtained by the user.}
  \item{\dots}{Additional arguments in the chosen method's function.}
}
\details{
The function returns the CCP value for predictive markers based on a user-chosen machine learning method. Currently available methods include logistic regression (default), tree, lda, svm and user-computed risk values. This function is general since we can evaluate the accuracy for marker combinations resulted from complicated classification algorithms.

}
\value{
Returns an object of class "mcca.ccp". The CCP value of the classification using a particular learning method on a set of marker(s).

An object of class "mcca.ccp" is a list containing at least the following components:
  \item{call}{the matched call.}
  \item{measure}{the value of measure.}
  \item{table}{the category-specific value of measure.}
}
\references{
Li, J., Gao, M., D’Agostino, R. (2019). Evaluating Classification Accuracy for Modern Learning Approaches. Statistics in Medicine (Tutorials in Biostatistics). 38(13): 2477-2503.

Li, J., Jiang, B. and Fine, J. P. (2013). Multicategory reclassification statistics for assessing Improvements in diagnostic accuracy. Biostatistics. 14(2): 382-394.

Li, J., Jiang, B., and Fine, J. P. (2013). Letter to Editor: Response. Biostatistics. 14(4): 809-810.
}
\author{
Ming Gao: gaoming@umich.edu

Pan Liu: pan.liu@nus.edu.sg

Jialiang Li: stalj@nus.edu.sg
}
\note{
Users are advised to change the operating settings of various classifiers since it is well known that machine learning methods require extensive tuning. Currently only some common and intuitive options are set as default and they are by no means the optimal parameterization for a particular data analysis. Users can put machine learning methods' parameters after tuning. A more flexible evaluation is to consider "method=label" in which case the input d should be a label vector.
}
\seealso{
\code{\link{pdi}}
}
\examples{
str(iris)
data <- iris[, 1:4]
label <- iris[, 5]
ccp(y = label, d = data, method = "multinom",maxit = 1000,MaxNWts = 2000,trace=FALSE)

## Call:
## ccp(y = label, d = data, method = "multinom", maxit = 1000,
##     MaxNWts = 2000, trace = FALSE)

## Overall Correct Classification Probability:
##  0.9866667

## Category-specific Correct Classification Probability:
##   CATEGORIES VALUES PREVALENCE
## 1     setosa   1.00  0.3333333
## 2 versicolor   0.98  0.3333333
## 3  virginica   0.98  0.3333333

ccp(y = label, d = data, method = "multinom")
ccp(y = label, d = data, method = "svm")
ccp(y = label, d = data, method = "svm",kernel="sigmoid",cost=4,scale=TRUE,coef0=0.5)
ccp(y = label, d = data, method = "tree")

p = as.numeric(label)
ccp(y = label, d = p, method = "label")


table(mtcars$carb)
for (i in (1:length(mtcars$carb))) {
  if (mtcars$carb[i] == 3 | mtcars$carb[i] == 6 | mtcars$carb[i] == 8) {
    mtcars$carb_new[i] = 9
  }else{
    mtcars$carb_new[i] = mtcars$carb[i]
  }
}
data <- data.matrix(mtcars[, c(1)])
mtcars$carb_new <- factor(mtcars$carb_new)
label <- mtcars$carb_new
str(mtcars)
ccp(y = as.numeric(label), d = data, method = "svm",kernel="radial",cost=1,scale=TRUE)

## Call:
## ccp(y = as.numeric(label), d = data, method = "svm", kernel = "radial", cost = 1, scale = TRUE)

## Overall Correct Classification Probability:
##  0.4375

## Category-specific Correct Classification Probability:
##   CATEGORIES    VALUES PREVALENCE
## 1          1 0.5714286    0.21875
## 2          2 0.2000000    0.31250
## 3          3 0.8000000    0.31250
## 4          4 0.0000000    0.15625

}
\keyword{ CCP }

\name{hum}
\alias{hum}
\title{Calculate HUM Value}
\usage{
hum(y, d, method="multinom", \dots)
}
\description{
compute the Hypervolume Under Manifold (HUM) value of two or three or four categories classifiers with an option to define the specific model or user-defined model.
}
\arguments{
  \item{y}{The multinomial response vector with two, three or four categories. It can be factor or integer-valued.}
  \item{d}{The set of candidate markers, including one or more columns. Can be a data frame or a matrix; if the method is "prob", then d should be the probablity matrix.}
  \item{method}{Specifies what method is used to construct the classifier based on the marker set in d. Available option includes the following methods:"multinom": Multinomial Logistic Regression which is the default method, requiring R package nnet;"tree": Classification Tree method, requiring R package rpart;"svm": Support Vector Machine (C-classification and radial basis as default), requiring R package e1071;"lda": Linear Discriminant Analysis, requiring R package lda;"prob": d is a risk matrix resulted from any external classification algorithm obtained by the user.}
  \item{\dots}{Additional arguments in the chosen method's function.}
}
\details{
The function returns the HUM value for predictive markers based on a user-chosen machine learning method. Currently available methods include logistic regression (default), tree, lda, svm and user-computed risk values. For binary outcome, one can use AUC value (HUM reduces to AUC in such case). This function is more general than the package HUM, since we can evaluate the accuracy for marker combinations resulted from complicated classification algorithms.

}
\value{
The HUM value of the classification using a particular learning method on a set of marker(s).
}
\references{
Li, J., Gao, M., D’Agostino, R. (2019). Evaluating Classification Accuracy for Modern Learning Approaches. Statistics in Medicine (Tutorials in Biostatistics). 38(13): 2477-2503.

Li, J. and Fine, J. P. (2008): ROC analysis with multiple tests and multiple classes: methodology and applications in microarray studies. Biostatistics. 9 (3): 566-576.

Li, J., Chow, Y., Wong, W.K., and Wong, T.Y. (2014). Sorting Multiple Classes in Multi-dimensional ROC Analysis: Parametric and Nonparametric Approaches. Biomarkers. 19(1): 1-8.
}
\author{
Ming Gao: gaoming@umich.edu

Pan Liu: pan.liu@nus.edu.sg

Jialiang Li: stalj@nus.edu.sg
}
\note{
Users are advised to change the operating settings of various classifiers since it is well known that machine learning methods require extensive tuning. Currently only some common and intuitive options are set as default and they are by no means the optimal parameterization for a particular data analysis. Users can put machine learning methods' parameters after tuning. A more flexible evaluation is to consider "method=prob" in which case the input d should be a matrix of membership probabilities with k columns and each row of d should sum to one.
}
\seealso{
\code{\link{pdi}}
}
\examples{
str(iris)
data <- iris[, 1:4]
label <- iris[, 5]
hum(y = label, d = data,method = "multinom")
## [1] 0.9972
hum(y = label, d = data,method = "svm")
## [1] 0.9964
hum(y = label, d = data,method = "svm",type="C",kernel="linear",cost=4,scale=TRUE)
## [1] 0.9972
hum(y = label, d = data, method = "tree")
## [1] 0.998

data <- data.matrix(iris[, 1:4])
label <- as.numeric(iris[, 5])
# multinomial
require(nnet)
# model
fit <- multinom(label ~ data, maxit = 1000, MaxNWts = 2000)
predict.probs <- predict(fit, type = "probs")
pp<- data.frame(predict.probs)
# extract the probablity assessment vector
head(pp)
hum(y = label, d = pp, method = "prob")
## [1] 0.9972

table(mtcars$carb)
for (i in (1:length(mtcars$carb))) {
  if (mtcars$carb[i] == 3 | mtcars$carb[i] == 6 | mtcars$carb[i] == 8) {
    mtcars$carb_new[i] = 9
  }else{
    mtcars$carb_new[i] = mtcars$carb[i]
  }
}
data <- data.matrix(mtcars[, c(1:10)])
mtcars$carb_new <- factor(mtcars$carb_new)
label <- mtcars$carb_new
str(mtcars)

hum(y = label, d = data, method = "tree",control = rpart::rpart.control(minsplit = 5))
## [1] 1
hum(y = label, d = data, method = "svm",kernel="linear",cost=0.7,scale=TRUE)
## [1] 1
hum(y = label, d = data, method = "svm", kernel ="radial",cost=0.7,scale=TRUE)
## [1] 0.53
}
\keyword{ HUM }

\name{print.mcca.pdi.var}
\alias{print.mcca.pdi.var}
\title{Print Method for mcca pdi.var class}
\usage{
\method{print}{mcca.pdi.var}(x, ...)
}
\description{
An S3 method for the print generic. It is designed for a quick look at PDI values with variance estimation.
}
\arguments{
  \item{x}{object of class `mcca.pdi.var`.}
  \item{\dots}{further arguments to `print.default`.}
}

\value{
An object of class "mcca.pdi.var" is a list containing at least the following components:
  \item{call}{the matched call.}
  \item{measure}{the overall PDI value.}
  \item{se}{the calculated standard error of the overall PDI.}
  \item{ci}{the confidence interval for the overall PDI.}
  \item{level}{the confidence level used.}
  \item{table}{a data frame with category-specific PDI values, standard errors, and confidence intervals.}
}
\references{
Feng, Q., Jia, T., Liu, P., Van Calster, B., Li J. (2026). Efficient variance estimation for the polytomous discrimination index. Statistics in Medicine.

Dover, D.C., Savu, A., Engel, B. (2021). Polytomous discrimination index: Estimation and inference. Statistics in Medicine.

Li, J., Gao, M., D'Agostino, R. (2019). Evaluating Classification Accuracy for Modern Learning Approaches. Statistics in Medicine (Tutorials in Biostatistics). 38(13): 2477-2503.
}
\author{
Ming Gao: gaoming@umich.edu

Pan Liu: pan.liu@nus.edu.sg

Jialiang Li: stalj@nus.edu.sg
}

\examples{
data = iris[, 1:4]
label = iris[, 5]
pdi_var_object = pdi(y = label, d = data, method = "multinom", Var = TRUE)
print(pdi_var_object)

}
\keyword{PDI}
